      subroutine patter(ier)
      character*80 name,powf
      character cff,space*16,laues*5
c
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/xdata/x(244000)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /atoms/ xyz(5,200),icvet(200),ngp,ninf(10),nag(10)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isn(2,3,24),tsn(3,24),nnsym,pts,ksys,ncent,latt,s3s2,
     *          emme,s3s2p
      common /setequ/ jpatt,jpunt(501),ksacc,jseteq,jumpp
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c*****************
c
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1 ,120('+'),//,
     1 39h SIRPOW.92 : Patterson routine         ,68x,14hRelease  93.05
     2 ,//,20x,20a4,/,1h ,120('+'),//,
     *       40x,'***   patterson synthesis section    ***',/)
c++++++
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call ysfl07(nrifl,mmm,mmmz,npseud,iy)
CORIG                 if(sc.lt.0.0) then
CORIG                                  write(lo,9040)
CORIG                                  ier=-1
CORIG                               endif 
                      else
                         write(lo,9050)
                         ier=-1
                    endif
      if(ier.lt.0) return
      itype=1
      iform=2
      jop=jopen(jrel ,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      jop=jopen(ifour,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9010
c
      call defco(nsize)
      call dirpat(ier)
      if (ier.lt.0) return
      if (sc.lt.0.0.and.jpatt.ne.2) then
                       write(lo,9040)
                       ier=-1
                     endif
c++++++
      call yfl02
c-- modifica degli operatori di simmetria
      do 11 i=1,nnsym
      do 12 j=1,3
      tmat(i,j)=0
   12 continue
   11 continue
      ncent=1
      call musym(kmat,tmat,nnsym,isn,tsn)
      write(space,'(16a1)') nt
      call laue(space,jsys,laues)
      if (jpatt.eq.1) then
                         write(lo,18)
                       else if (jpatt.eq.2) then
                         write(lo,19)
                        else
                         write(lo,20)
                       endif
      write(lo,15) laues
   15 format(48x,' Laue class: ',a5,//)
   18 format(/,48x,' /E/**2 coefficients ')
   19 format(/,48x,' /F/**2 coefficients ')
   20 format(/,48x,' /F/*/E/ coefficients ')
      mode=1
      numb2=0
c-new
      powf='(3i4,f8.2,8x,f8.2,f8.5)                 '
      jpowd=0
      negmp=0
      istop=0
      call fft(powf,jpowd,ihalf,numb2,anat,ccfom,
     *         nsize,negmp,mode,istop,ier)
      if (ier.lt.0) return
c
      write(lo,120) 
  120 format(2h  ,4hpeak,2x,6hheight,5x,1hx,6x,1hy,6x,1hz,3x,6h occ. )
      do 150 i=1,nats
      kk=xyz(4,i)+0.5
      write(lo,140) i,kk,(xyz(j,i),j=1,3),abs(xyz(5,i))
  150 continue
  140 format(i5,i8,2x,3f7.3,f8.4)
      close(jrel )
      close(ifour)
c-- reset variable jpatt
      jpatt = 0
      return
 9000 continue
      write(lo,9020) ier,jrel
      ier=-1
      return
 9010 continue
      write(lo,9030) ier,ifour
      ier=-1
 9020 format(' *** error ***  open error on scratch file jrel, code ='
     *,i5,',  channel =',i5)
 9030 format(' *** error ***  open error on scratch file ifour, code ='
     *,i5,',  channel =',i5)
 9040 format(' *** error ***  reflections must be normalized ')
 9050 format(' *** error ***  no reflections in direct acces file ')
      return
      end
c----------------------------------------------------------------------
      subroutine dirpat(ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /sdir/ dm,npc,nproj,nojoin,jplt
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common /setequ/ jpatt,jpunt(501),ksacc,jseteq,jumpp
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      dimension vet(40),ivet(40)
c-- set default values
c
      jspini=-1
      iprin=0
      nsec=1
      jmpsie=1
      jpatt=1
      npc=0
      factr= 1.0/3.0
      it4=0
      level = 100
      xlim(1)=1.0
      xlim(2)=1.0
      xlim(3)=1.0
c
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (dire(1:4).eq.'layy') then
          nsec=1
          go to 100
          endif
      if (dire(1:4).eq.'layx') then
          nsec=2
          go to 100
          endif
      if (dire(1:4).eq.'layz') then
          nsec=3
          go to 100
          endif
      if (dire(1:4).eq.'e**2'.or.dire(1:4).eq.'e*e') then
          jpatt=1
          go to 100
          endif
      if (dire(1:4).eq.'f**2'.or.dire(1:4).eq.'f*f') then
          jpatt=2
          go to 100
          endif
      if (dire(1:3).eq.'f*e'.or.dire(1:3).eq.'e*f') then
          jpatt=3
          go to 100
          endif
      if (dire(1:3).eq.'map' ) then
          it4=lo
          go to 100
          endif
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 9000
      if (dire(1:4).eq.'peak') then
          if (iv.ne.1) go to 9000
          npc=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'grid') then
          if (iv.ne.1) go to 9000
          factr=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 9000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'limi') then
          if (iv.ne.3) go to 9000
          do 7500 i=1,3
 7500     xlim(i)=amin1(vet(i),1.0)
          go to 100
          endif
      write(lo,6500) diret
 6500 format(' wrong directive on following line:',/a)
      ier=-1
      return
 8000 continue
      return
 9000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
      end
c--------------------------------------------------------------------
      subroutine laue(space,jsys,laues)
      character space*16,laues*5,string*16,dire*16
c
      if (jsys.le.3) then
                       if (jsys.eq.1) then
                                        laues=' -1  '
                  else if (jsys.eq.2) then
                                        laues=' 2/m '
                  else if (jsys.eq.3) then
                                        laues=' mmm '
                                      endif
                     else
                       string=space 
                       call cutst(string,lens,dire,lend)
c--calcola il numero di operatori
                       nop=1
                       do 40 i=1,3
                       call cutst(string,lens,dire,lend)
                       if (lens.le.0) go to 45
                       nop=nop+1
   40                  continue 
   45                  continue 
           if (jsys.eq.4) then
                if (nop.eq.1) then
                                laues=' 4/m '
                              else 
                                laues='4/mmm'
                              endif
       else if (jsys.eq.5) then
                 j=index(space,'3')
                 if (j.eq.0) then
                  if (nop.eq.1) then
                                   laues=' 6/m '
                                 else 
                                   laues='6/mmm'
                                 endif
                              else 
                     if (nop.eq.1) then
                                      laues='  -3 '
                                    else  
                                      laues=' -3m '
                                    endif 
                                endif
        else          
             if (nop.eq.2) then
                             laues=' m-3 '
                           else 
                            laues=' m-3m'
                           endif
                       endif
                       endif
        return
        end  
